import {
  getEndpoint
} from "./shared.js";
import { buildRequestParams } from "./../helpers/index.js";
function performRequest(operation, operationName, method, options) {
  return $fetch(getEndpoint(operation, operationName), {
    ...options,
    method
  }).then((v) => {
    return {
      data: v.data,
      errors: v.errors || []
    };
  });
}
export function useGraphqlQuery(...args) {
  const [name, variables, fetchOptions = {}] = typeof args[0] === "string" ? [args[0], args[1]] : [args[0].name, args[0].variables, args[0].fetchOptions];
  return performRequest("query", name, "get", {
    params: buildRequestParams(variables),
    ...fetchOptions
  });
}
export function useGraphqlMutation(...args) {
  const [name, body, fetchOptions = {}] = typeof args[0] === "string" ? [args[0], args[1]] : [args[0].name, args[0].variables, args[0].fetchOptions];
  return performRequest("mutation", name, "post", {
    body,
    ...fetchOptions
  });
}
