import { type GraphqlMiddlewareQueryName, type KeysOf, type PickFrom } from './shared.js';
import type { FetchOptions } from 'ofetch';
import { type Ref } from 'vue';
import type { GraphqlMiddlewareQuery } from '#build/nuxt-graphql-middleware';
import type { GraphqlResponse } from '#graphql-middleware-server-options-build';
import type { RequestCacheOptions } from '#graphql-middleware/types';
import type { AsyncData, AsyncDataOptions, NuxtError } from '#app';
type AsyncGraphqlQueryOptions<ResponseType, DefaultT, Keys extends KeysOf<DefaultT>, F> = AsyncDataOptions<ResponseType, DefaultT, Keys> & {
    graphqlCaching?: RequestCacheOptions;
    fetchOptions?: F;
};
/**
 * Wrapper for useAsyncData to perform a single GraphQL query.
 */
export declare function useAsyncGraphqlQuery<Name extends GraphqlMiddlewareQueryName, VarType extends GraphqlMiddlewareQuery[Name][0], VarsOptional extends GraphqlMiddlewareQuery[Name][1], ResponseType extends GraphqlResponse<GraphqlMiddlewareQuery[Name][2]>, F extends FetchOptions<'json'>, DefaultT = ResponseType, Keys extends KeysOf<DefaultT> = KeysOf<DefaultT>>(name: Name, ...args: VarsOptional extends true ? [
    (undefined | null | Record<string, never> | VarType | Ref<VarType>)?,
    AsyncGraphqlQueryOptions<ResponseType, DefaultT, Keys, F>?
] : [
    VarType | Ref<VarType>,
    (undefined | null | AsyncGraphqlQueryOptions<ResponseType, DefaultT, Keys, F>)?
]): AsyncData<PickFrom<DefaultT, KeysOf<DefaultT>> | null, NuxtError<unknown> | null>;
export {};
