import { type GraphqlMiddlewareQueryName, type GetQueryArgs, type QueryObjectArgs, type GetQueryResult } from './shared.js';
import type { GraphqlMiddlewareQuery } from '#build/nuxt-graphql-middleware';
import type { GraphqlResponse } from '#graphql-middleware-server-options-build';
/**
 * Performs a GraphQL query.
 */
export declare function useGraphqlQuery<T extends GraphqlMiddlewareQueryName, R extends GetQueryResult<T, GraphqlMiddlewareQuery>>(...args: GetQueryArgs<T, GraphqlMiddlewareQuery> | [QueryObjectArgs<T, GraphqlMiddlewareQuery>]): Promise<GraphqlResponse<R>>;
