/**
 * Simple LRU (least recently used) cache.
 *
 * Keeps the amount of cached items limited to the given max size.
 * Once that number is reached, the cache item used the least is removed.
 */
export declare class GraphqlMiddlewareCache {
    cache: Record<string, unknown>;
    keys: string[];
    maxSize: number;
    constructor(maxSize?: number);
    set(key: string, value: unknown): void;
    get<T>(key: string): T | undefined;
    purge(): void;
}
